package com.webratio.units.custom;

import org.dom4j.Element;

import com.webratio.rtx.RTXException;
import com.webratio.rtx.RTXManager;
import com.webratio.rtx.core.BeanHelper;
import com.webratio.rtx.core.DescriptorHelper;
import com.webratio.rtx.validation.AbstractFieldValidationRuleService;
import com.webratio.rtx.validation.NextValidationPolicy;
import com.webratio.rtx.validation.RTXField;

public class WordsNumberValidationRuleService extends AbstractFieldValidationRuleService {

	private final int wordsNumber;
	
    public WordsNumberValidationRuleService(String id, RTXManager mgr, Element descr) throws RTXException {
        super(id, mgr, descr);
        String value = DescriptorHelper.getChildValue(descr, "WordsNumber", true, this);
        this.wordsNumber = Integer.parseInt(value);
    }
    
    public NextValidationPolicy validate(RTXField field) throws RTXException {
        String[] words = null;
        String value = BeanHelper.asString(field.getValue());
        
        if (!BeanHelper.isNullOrEmptyString(value)){
        	words = value.split(" ");
        	if (words.length <= wordsNumber){
        		return NextValidationPolicy.CONTINUE;
        	} else {
	        	field.addError(this.getBundleKey());
	        	return NextValidationPolicy.SKIP;
        	}
        } else {
        	return NextValidationPolicy.CONTINUE;
        }
    }

}